library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
entity vhdl_block_pattern_sym_table is
  generic (
    DEPTH : integer := 5;
    WIDTH : integer := 8 );

  port (
    clk   : in  std_logic;
    reset : in  std_logic;
    data_raddr : in  std_logic_vector(31 downto 0);
    data_rdata : out std_logic_vector(7 downto 0) );

end vhdl_block_pattern_sym_table;

architecture RTL of vhdl_block_pattern_sym_table is

  type rom_type is array (0 to 20) of std_logic_vector (WIDTH-1 downto 0);
  constant ROM: rom_type := (
  "01100001", "01100010", "01100011", "01100100", "01100101", "01100110", "01100111", "01101000", "01101001", "01101010", "01101011", "01101100", "01101101", "01101110", "01101111", "01110000", "01110001", "01110010", "01110011", "01110100", "01110101"
  );  signal q : std_logic_vector(7 downto 0);
begin  -- RTL

  data_rdata <= q;

  process (clk)
  begin
    if clk'event and clk = '1' then
      q <= ROM(conv_integer(data_raddr(DEPTH-1 downto 0)));
    end if;
  end process;

end RTL;
